From 4e068489ca99c07fbce2a712ed141440c00c1b0f Mon Sep 17 00:00:00 2001
From: Daniel White <daniel@whitehouse.id.au>
Date: Mon, 2 Jan 2017 23:50:21 +0930
Subject: [PATCH] Fix deinstall of multiplexer when a default exists.

This copes with a somewhat subtle case where a default exists but the
last generator is removed. By inverting the checks, we can ensure we
only look at the cdr of the generator list when generators is actually a
pair.

The bug was originally exhibited by an error when removing the last
generator with remove-generic-procedure-generator on a generic procedure
with a default generator.
---
 src/runtime/genmult.scm        |  8 +++---
 tests/check.scm                |  1 +
 tests/runtime/test-genmult.scm | 55 ++++++++++++++++++++++++++++++++++++++++++
 3 files changed, 60 insertions(+), 4 deletions(-)
 create mode 100644 tests/runtime/test-genmult.scm

diff --git a/src/runtime/genmult.scm b/src/runtime/genmult.scm
index b29bab9..150f0aa 100644
--- a/src/runtime/genmult.scm
+++ b/src/runtime/genmult.scm
@@ -115,11 +115,11 @@ USA.
 (define (maybe-deinstall-multiplexer generic)
   (let* ((m (generic-procedure-generator generic))
 	 (generators (multiplexer-list m)))
-    (cond ((and (not (pair? generators))
-		(not (multiplexer-default m)))
+    (cond ((and (not (multiplexer-default m))
+		(not (pair? generators)))
 	   (set-generic-procedure-generator! generic #f))
-	  ((and (not (pair? (cdr generators)))
-		(not (multiplexer-default m)))
+	  ((and (not (multiplexer-default m))
+		(not (pair? (cdr generators))))
 	   (set-generic-procedure-generator! generic (car generators))))))
 
 (define (make-multiplexer)
diff --git a/tests/check.scm b/tests/check.scm
index 90ebb69..0b2bbab 100644
--- a/tests/check.scm
+++ b/tests/check.scm
@@ -49,6 +49,7 @@ USA.
     "runtime/test-entity"
     "runtime/test-ephemeron"
     "runtime/test-floenv"
+    "runtime/test-genmult"
     "runtime/test-hash-table"
     "runtime/test-integer-bits"
     "runtime/test-mime-codec"
diff --git a/tests/runtime/test-genmult.scm b/tests/runtime/test-genmult.scm
new file mode 100644
index 0000000..a21323f
--- /dev/null
+++ b/tests/runtime/test-genmult.scm
@@ -0,0 +1,55 @@
+#| -*-Scheme-*-
+
+Copyright (C) 1986, 1987, 1988, 1989, 1990, 1991, 1992, 1993, 1994,
+    1995, 1996, 1997, 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005,
+    2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015, 2016,
+    2017 Massachusetts Institute of Technology
+
+This file is part of MIT/GNU Scheme.
+
+MIT/GNU Scheme is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2 of the License, or (at
+your option) any later version.
+
+MIT/GNU Scheme is distributed in the hope that it will be useful, but
+WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with MIT/GNU Scheme; if not, write to the Free Software
+Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301,
+USA.
+
+|#
+
+;;; Tests of Multiplexed Generic Procedures
+
+(declare (usual-integrations))
+
+(define-test 'REGRESSION:REMOVE-GENERIC-PROCEDURE-GENERATOR
+  (lambda ()
+    (define generic (make-generic-procedure 1))
+    ;; Bug exhibited itself in the face of a default generator.
+    (set-generic-procedure-default-generator!
+     generic
+     (lambda _ (lambda _ 'not-specialised)))
+    (assert-equal (generic #\a) 'not-specialised)
+    ;; Add some named generators (for easier removal).
+    (define (bool-generator p tags)
+      (if (equal? tags (list (built-in-dispatch-tag 'boolean)))
+          (lambda (x) (cons 'boolean x))
+          #f))
+    (add-generic-procedure-generator generic bool-generator)
+    (assert-equal (generic #t) '(boolean . #t))
+    (define (fixnum-generator p tags)
+      (if (equal? tags (list (built-in-dispatch-tag 'fixnum)))
+          (lambda (x) (cons 'fixnum x))
+          #f))
+    (add-generic-procedure-generator generic fixnum-generator)
+    (assert-equal (generic 42) '(fixnum . 42))
+    ;; Remove members, ensuring they are all removed.
+    (remove-generic-procedure-generator generic bool-generator)
+    (remove-generic-procedure-generator generic fixnum-generator)
+    (assert-eq (generic-procedure-generator-list generic) '())))
-- 
2.8.3